#!/bin/bash
#
# Apache ActiveMQ startup script
#
# chkconfig: - 73 11
# description: ActiveMQ

# Rev7
#Syslog message on shutdown added

# Rev8
# Changed preference: .bash_profile over .profile
# Fix for two weblogic users on the same host

# Rev9
# Linux SystemD support + eval

# Rev10
# VIP support

# Rev11
# Veritas Cluster monitor script support on exit code 100

# Rev12
# Support RHEL\OEL 8 (Linux ver.8)


prog=ActiveMQ

WLS_USER={{ activemq_user }}
HOME_FOLDER=`grep "^${WLS_USER}:" /etc/passwd | cut -d ':' -f 6`
AMQ_HOME=${HOME_FOLDER}/apache-activemq
JAVA_HOME={{ java_home }}

#-------------------------------------------
#If running in Cluster environment set USE_CLUSER variable to TRUE otherwise set it to FALSE.
USE_CLUSTER="FALSE"


#Do we need to add VIP (Virtual IP) address first?
USE_VIP=NO
VIP_ADDR=172.30.42.113
VIP_MASK=26
VIP_DEV=ens32
GW_IP=172.30.42.65


SHUT_MSG="Apache ActiveMQ shutdown succeeded"

LOCK_FILE=/tmp/activemq

if [ -e ${HOME_FOLDER}/.bash_profile ]
        then
                USER_PROFILE=${HOME_FOLDER}/.bash_profile
        else
                USER_PROFILE=${HOME_FOLDER}/.profile
fi

create_lock_file() {

if [ "$USE_CLUSTER" == "FALSE" ]

        then

                #Create lock file to exclude multiple instances of the script
                if [ -e $LOCK_FILE ]
                        then
                                echo "Another instance of the script running... Or check for lock file: $LOCK_FILE"
                                exit 255
                fi

                touch $LOCK_FILE

        else
                echo ""
                echo "Assuming using script in the Cluster Environment"
                echo "Multiply instances of script is permitted. Cluster must take care about it"
                echo ""
fi
}

remove_lock_file() {
if [ "$USE_CLUSTER" == "FALSE" ]
        then
                rm -f $LOCK_FILE
fi
}


case `uname` in
    AIX)
        OS=AIX
        SHUT_LOG_CMD="/usr/bin/logger -puser.debug -t activemq '${SHUT_MSG}'"
                case "$USER" in
                        root)

                                START_CMD="su - $WLS_USER -c \". $USER_PROFILE >/dev/null 2>&1;export ACTIVEMQ_HOME=${AMQ_HOME};${AMQ_HOME}/bin/activemq start >/dev/null 2>&1\""
                                STOP_CMD="su - $WLS_USER -c \". $USER_PROFILE > /dev/null 2>&1;export ACTIVEMQ_HOME=${AMQ_HOME}; ${AMQ_HOME}/bin/activemq stop >/dev/null 2>&1\""
                                STATUS_CMD="su - $WLS_USER -c \". $USER_PROFILE > /dev/null 2>&1;export ACTIVEMQ_HOME=${AMQ_HOME};${AMQ_HOME}/bin/activemq status >/dev/null 2>&1\""

                        ;;

                        ${WLS_USER})

                                START_CMD=". $USER_PROFILE >/dev/null 2>&1;export ACTIVEMQ_HOME=${AMQ_HOME};${AMQ_HOME}/bin/activemq start >/dev/null 2>&1"
                                STOP_CMD=". $USER_PROFILE > /dev/null 2>&1;export ACTIVEMQ_HOME=${AMQ_HOME}; ${AMQ_HOME}/bin/activemq stop >/dev/null 2>&1"
                                STATUS_CMD=". $USER_PROFILE > /dev/null 2>&1;export ACTIVEMQ_HOME=${AMQ_HOME};${AMQ_HOME}/bin/activemq status >/dev/null 2>&1"
                        ;;

                        *)

                                START_CMD="su - $WLS_USER -c \". $USER_PROFILE >/dev/null 2>&1;export ACTIVEMQ_HOME=${AMQ_HOME};${AMQ_HOME}/bin/activemq start >/dev/null 2>&1\""
                                STOP_CMD="su - $WLS_USER -c \". $USER_PROFILE > /dev/null 2>&1;export ACTIVEMQ_HOME=${AMQ_HOME}; ${AMQ_HOME}/bin/activemq stop >/dev/null 2>&1\""
                                STATUS_CMD="su - $WLS_USER -c \". $USER_PROFILE > /dev/null 2>&1;export ACTIVEMQ_HOME=${AMQ_HOME};${AMQ_HOME}/bin/activemq status >/dev/null 2>&1\""
                        ;;
                esac
    ;;

    Linux)
        OS=Linux
        SHUT_LOG_CMD="/usr/bin/logger -t activemq '${SHUT_MSG}'"

        case "$USER" in
            root)

                START_CMD="su - ${WLS_USER} -c \". $USER_PROFILE >/dev/null 2>&1;export ACTIVEMQ_HOME=${AMQ_HOME};${AMQ_HOME}/bin/activemq start >/dev/null 2>&1\""
                STOP_CMD="su - ${WLS_USER} -c \". $USER_PROFILE > /dev/null 2>&1;export ACTIVEMQ_HOME=${AMQ_HOME}; ${AMQ_HOME}/bin/activemq stop >/dev/null 2>&1\""
                STATUS_CMD="su - ${WLS_USER} -c \". $USER_PROFILE > /dev/null 2>&1;export ACTIVEMQ_HOME=${AMQ_HOME};${AMQ_HOME}/bin/activemq status >/dev/null 2>&1\""

                ADD_VIP="ip addr add ${VIP_ADDR}/${VIP_MASK} dev $VIP_DEV"
                DEL_VIP="ip addr del ${VIP_ADDR}/${VIP_MASK} dev $VIP_DEV"

                PING_GW="ping -c 2 -I $VIP_ADDR $GW_IP"
                PING_ARP="/sbin/arping -U -c 2 -s $VIP_ADDR -I $VIP_DEV $GW_IP"
            ;;

            ${WLS_USER})
                START_CMD=". $USER_PROFILE >/dev/null 2>&1;export ACTIVEMQ_HOME=${AMQ_HOME};${AMQ_HOME}/bin/activemq start >/dev/null 2>&1"
                STOP_CMD=". $USER_PROFILE > /dev/null 2>&1;export ACTIVEMQ_HOME=${AMQ_HOME}; ${AMQ_HOME}/bin/activemq stop >/dev/null 2>&1"
                STATUS_CMD=". $USER_PROFILE > /dev/null 2>&1;export ACTIVEMQ_HOME=${AMQ_HOME};${AMQ_HOME}/bin/activemq status >/dev/null 2>&1"
                ADD_VIP="sudo ip addr add ${VIP_ADDR}/${VIP_MASK} dev $VIP_DEV"
                DEL_VIP="sudo ip addr del ${VIP_ADDR}/${VIP_MASK} dev $VIP_DEV"
                PING_GW="ping -c 2 -I $VIP_ADDR $GW_IP"
                PING_ARP="/sbin/arping -U -c 2 -s $VIP_ADDR -I $VIP_DEV $GW_IP"

            ;;

            *)

                START_CMD="su - ${WLS_USER} -c \". $USER_PROFILE >/dev/null 2>&1;export ACTIVEMQ_HOME=${AMQ_HOME};${AMQ_HOME}/bin/activemq start >/dev/null 2>&1\""
                STOP_CMD="su - ${WLS_USER} -c \". $USER_PROFILE > /dev/null 2>&1;export ACTIVEMQ_HOME=${AMQ_HOME}; ${AMQ_HOME}/bin/activemq stop >/dev/null 2>&1\""
                STATUS_CMD="su - ${WLS_USER} -c \". $USER_PROFILE > /dev/null 2>&1;export ACTIVEMQ_HOME=${AMQ_HOME};${AMQ_HOME}/bin/activemq status >/dev/null 2>&1\""
            ;;
        esac

    ;;

    SunOS)
        OS=SunOS
        SHUT_LOG_CMD="/usr/bin/logger -t activemq '${SHUT_MSG}'"
                case "$USER" in
                        root)

                                START_CMD="su - ${WLS_USER} -c \". $USER_PROFILE >/dev/null 2>&1;export ACTIVEMQ_HOME=${AMQ_HOME};${AMQ_HOME}/bin/activemq start >/dev/null 2>&1\""
                                STOP_CMD="su - ${WLS_USER} -c \". $USER_PROFILE > /dev/null 2>&1;export ACTIVEMQ_HOME=${AMQ_HOME}; ${AMQ_HOME}/bin/activemq stop >/dev/null 2>&1\""
                                STATUS_CMD="su - ${WLS_USER} -c \". $USER_PROFILE > /dev/null 2>&1;export ACTIVEMQ_HOME=${AMQ_HOME};${AMQ_HOME}/bin/activemq status >/dev/null 2>&1\""

                        ;;

                        ${WLS_USER})

                                START_CMD=". $USER_PROFILE >/dev/null 2>&1;export ACTIVEMQ_HOME=${AMQ_HOME};${AMQ_HOME}/bin/activemq start >/dev/null 2>&1"
                                STOP_CMD=". $USER_PROFILE > /dev/null 2>&1;export ACTIVEMQ_HOME=${AMQ_HOME}; ${AMQ_HOME}/bin/activemq stop >/dev/null 2>&1"
                                STATUS_CMD=". $USER_PROFILE > /dev/null 2>&1;export ACTIVEMQ_HOME=${AMQ_HOME};${AMQ_HOME}/bin/activemq status >/dev/null 2>&1"
                        ;;

                        *)

                                START_CMD="su - $WLS_USER -c \". $USER_PROFILE >/dev/null 2>&1;export ACTIVEMQ_HOME=${AMQ_HOME};${AMQ_HOME}/bin/activemq start >/dev/null 2>&1\""
                                STOP_CMD="su - $WLS_USER -c \". $USER_PROFILE > /dev/null 2>&1;export ACTIVEMQ_HOME=${AMQ_HOME}; ${AMQ_HOME}/bin/activemq stop >/dev/null 2>&1\""
                                STATUS_CMD="su - $WLS_USER -c \". $USER_PROFILE > /dev/null 2>&1;export ACTIVEMQ_HOME=${AMQ_HOME};${AMQ_HOME}/bin/activemq status >/dev/null 2>&1\""
                        ;;
                esac
    ;;

    *)
        echo "Cant determine OS"
    ;;
esac;


grep JAVA_HOME $USER_PROFILE >/dev/null 2>&1

if [ $? -ne 0 ]
    then
        echo "JAVA_HOME variable is not specified, please add it into users profile"
        echo "It is needed for correct stop"
fi

EXIT_CODE=0

add_vip_addr() {

        if [ $USE_VIP == YES ]
                then
                        echo "Adding Virtual IP address"
                        eval $ADD_VIP
                        sleep 2
                        echo "Pinging Default Gateway"
                        eval $PING_GW
                        sleep 2
                        echo "Sending gratious ARP"
                        eval $PING_ARP
                else
                        echo "Adding Virtual IP address is not enabled"
        fi
}

remove_vip_addr() {
        if [ $USE_VIP == YES ]
                then
                        echo "Deleting Virtual IP address"
                        eval $DEL_VIP
                else
                        echo "Adding Virtual IP address is not enabled"
        fi
}


start() {
        echo "Starting $prog: "
    eval $START_CMD
        if [ $? -eq 0 ]
                then
                        EXIT_CODE=0
                else
                        EXIT_CODE=255
        fi

}

stop() {
    echo "Stopping $prog: "
    eval $STOP_CMD
        if [ $? -eq 0 ]
                then
                        EXIT_CODE=0
            eval $SHUT_LOG_CMD
                else
                        EXIT_CODE=255
        fi
}

status () {
    eval $STATUS_CMD
        PID=$?
        if [ $PID -eq 0 ]
                then
                        echo "$prog is running"
            EXIT_CODE=0
                else
                        echo "$prog is not running"
            ### To be compatible with Veritas Cluster
            EXIT_CODE=100
        fi
}

case "$1" in
        start)
                if [ "$UNAME" == "Linux" ] && [ $LINUX_RELEASE -lt 7 ]
                    then
                        touch /var/lock/subsys/wls${WLS_VERSION}
                fi
                create_lock_file
                add_vip_addr
                start
                remove_lock_file
        ;;
        stop)
                create_lock_file
                        stop
                remove_vip_addr
                remove_lock_file
        ;;
        status)
                status
        ;;
        add_vip)
                create_lock_file
                add_vip_addr
                remove_lock_file
        ;;

        del_vip)
                create_lock_file
                remove_vip_addr
                remove_lock_file
        ;;
        *)
        echo "Usage: $0 {start,stop,status}"
        exit 1
esac

if [ $EXIT_CODE -eq 0 ]
    then
        echo "Succeed"
    else
        echo "Failed"
fi
exit ${EXIT_CODE}
